#include "StdAfx.h"
#include "HttpDataChunks.h"

CHttpDataChunks::CHttpDataChunks(void)
{
}

CHttpDataChunks::~CHttpDataChunks(void)
{
	Clear();
}

void CHttpDataChunks::Add(void* pBuffer, DWORD size)
{
	HTTP_DATA_CHUNK* pChunk = new HTTP_DATA_CHUNK();
	pChunk->DataChunkType = HttpDataChunkFromMemory;
	pChunk->FromMemory.BufferLength = size;
	pChunk->FromMemory.pBuffer = pBuffer;
	this->AddTail(pChunk);
}

void CHttpDataChunks::Clear()
{
	POSITION pos = this->GetHeadPosition();
	while(pos!=NULL){
		delete (HTTP_DATA_CHUNK*)this->GetNext(pos);
	}
	this->RemoveAll();
}

ULONG CHttpDataChunks::GetByteCount()
{
	ULONG totalsize = 0;
	POSITION pos = this->GetHeadPosition();
	while(pos!=NULL){
		HTTP_DATA_CHUNK* pChunk = (HTTP_DATA_CHUNK*)this->GetNext(pos);
		totalsize += pChunk->FromMemory.BufferLength; //TODO: MODULE - overflow
	}
	return totalsize;
}

void CHttpDataChunks::Merge(void* destination)
{
	POSITION pos = this->GetHeadPosition();
	ULONG offset = 0;
	while(pos!=NULL){
		HTTP_DATA_CHUNK* pChunk = (HTTP_DATA_CHUNK*)this->GetNext(pos);
		memcpy(((char*)destination) + offset,pChunk->FromMemory.pBuffer,pChunk->FromMemory.BufferLength);
		offset += pChunk->FromMemory.BufferLength;
	}
}

CString CHttpDataChunks::ToString()
{
	CString data("");
	POSITION pos = this->GetHeadPosition();
	while(pos!=NULL){
		HTTP_DATA_CHUNK* pChunk = (HTTP_DATA_CHUNK*)this->GetNext(pos);
		data += CStringHelper::ConvertBinaryData((BYTE*)pChunk->FromMemory.pBuffer,pChunk->FromMemory.BufferLength,' ');
	}
	return data;
}
